package com.xxxxxxx.drvpp.fw.common.mybatis;

import java.io.IOException;
import java.io.Reader;

import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;

import com.xxxxxxx.drvpp.fw.common.exception.FwRuntimeException;

public class MyBatisSessionFactory {
	private static String resource = "mybatis.xml";
	private SqlSessionFactory sqlMapper;

	private static class MyBatisSessionFactoryHolder {
		private static final MyBatisSessionFactory instance = new MyBatisSessionFactory();
	}

	public static MyBatisSessionFactory getInstance() {
		MyBatisSessionFactoryHolder.instance.init();
		return MyBatisSessionFactoryHolder.instance;
	}

	public static void setResourceName(String name){
		resource = name;
	}

	private MyBatisSessionFactory() {

	}

	private void init() {
		Reader reader;
		try {
			reader = Resources.getResourceAsReader(resource);
			SqlSessionFactoryBuilder builder = new SqlSessionFactoryBuilder();
			sqlMapper = builder.build(reader);
		} catch (IOException e) {
			throw new FwRuntimeException(e);
		}
	}

	public SqlSession openSession() {
		return sqlMapper.openSession();
	}
}
